
#    Note:  This is loaded into the namespace  LyrTech

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable HelpTopic "undefined"

    variable UserLabel "test"

     variable crateID [first $crateList]
     variable boardID [first $boardList]

     variable allcrates 0
     variable allboards 0

   proc  show_variables {} {
       global MIDAS_VHSADCAccessServer_Exists
       global MIDAS_VHSADCAccessClient_Exists
       global VHSADCAccessServerHost
       global VHSADCAccessServerPort
       variable TestMode
       variable VHSADCLayOut
       variable crateList
       variable boardList
       variable crateID
       variable boardID
       variable allcrates
       variable allboards

      InsertLog "MIDAS_VHSADCAccessServer_Exists = [info exists MIDAS_VHSADCAccessServer_Exists]"
      InsertLog "MIDAS_VHSADCAccessClient_Exists = [info exists MIDAS_VHSADCAccessClient_Exists]"
      InsertLog "VHSADCAccessServerHost = $VHSADCAccessServerHost"
      InsertLog "VHSADCAccessServerPort = $VHSADCAccessServerPort"
      InsertLog "TestMode = $TestMode"
      InsertLog "VHSADCLayout = $VHSADCLayOut"
      InsertLog "crates = $crateList; boards = $boardList"
      InsertLog "crateID = $crateID; boardID = $boardID"
      InsertLog "all crates = $allcrates; all boards = $allboards"

    set rc [catch {VHSADCInit} Rmsg]
    InsertLog "VHSADCInit returned rc=$rc Rmsg=$Rmsg"

    set rc [catch {ReadVHSADCFpgaRegister $boardID 0} Rmsg]
    InsertLog "ReadVHSADCFpgaRegister returned rc=$rc Rmsg=$Rmsg"

    set rc [catch {ReadVHSADCCpldRegs $boardID} Rmsg]
    InsertLog "ReadVHSADCCpldRegs returned rc=$rc Rmsg=$Rmsg"

   }

   proc Help {subject} {
       variable HelpTopic

       switch $subject {

          Introduction -
          "Introduction to the System"  {set HelpTopic UsingVHSADCDataAcqAtGSI}

          default {}
       }

       do_help
   }


   proc do_BoardRegs {} {
     variable boardID

    InsertLog "VHS-ADC control registers for crate [GetVHSADCCrate] board $boardID"

    set info ""
    set i 0
    foreach offset [list 0x0 0x8 0xc 0x10 0x14 0x18 0x1c 0x20 0x24 0x28 0x2c 0x30 \
       0x34 0x38 0x3c 0x40 0x44] {

        set z [catch {ReadVHSADCFpgaRegister $boardID $offset} rc]
        if {$z == 0} {
            append info "[format 0x%03x $offset]=[format 0x%08x $rc]   "
        } else {
            InsertLog "Error reading FpgaReg offset=[format 0x%03x $offset]"
            append info "[format 0x%03x $offset]=**********   "
        }

        incr i
        if {$i == 4} {append info \n; set i 0}
    }
    InsertLog $info

    InsertLog "User-defined control registers"

    set info ""
    set i 0
    foreach offset [list 0x70 0x74 0x78 0x7c 0x100 0x104 0x108 0x10c 0x110 0x114 0x118 0x11c] {

        set z [catch {ReadVHSADCFpgaRegister $boardID $offset} rc]
        if {$z == 0} {
            append info "[format 0x%03x $offset]=[format 0x%08x $rc]   "
        } else {
            InsertLog "Error reading FpgaReg offset=[format 0x%03x $offset]"
            append info "[format 0x%03x $offset]=**********   "
        }

        incr i
        if {$i == 4} {append info \n; set i 0}
    }
    InsertLog $info
  }

   proc do_Report {} {
     variable boardID
     variable boardList
     variable allboards

#    Initialise - returns number of boards

    set rc [catch {VHSADCInit} m]
    if {$rc != 0} {InsertLog "VHSADCInit returned rc=$rc  m=$m"; return}
    
    InsertLog "Discovered $m boards in current crate"
    
    set board_SAVE $boardID
    
   foreach board $boardList {
   
      if {$allboards == 0 && $board != $boardID} {continue}
   
      set boardID $board
      
     InsertLog "VHS-ADC report for crate [GetVHSADCCrate]; board $boardID"

#    Get FPGA Revision

    set z [catch {expr [ReadVHSADCFpgaRegister $boardID 0] >> 16 & 255} rc1]
    InsertLog "ReadVHSADCFpgaRegister returned $z $rc1"

#    Get FPGA Board Status and Control Information

    set z [catch {ReadVHSADCFpgaRegister $boardID 0} rc2]
    InsertLog "ReadVHSADCFpgaRegister returned $z $rc2"

#    Get CPLD Registers Information

    set z [catch {ReadVHSADCCpldRegs $boardID} rc3]
    InsertLog "ReadVHSADCCpldRegs returned $z $rc3"

    set virtex_pgm [lindex $rc3 0]
    set adc_speed_status [lindex $rc3 1]
    set cpld_status [lindex $rc3 2]
    set cpld_revision [lindex $rc3 3]
    set pcb_revision [lindex $rc3 4]
    set sm_board_id [lindex $rc3 5]

#    print board info

    switch $sm_board_id {
         0x82  {set infos "VHS-ADC 8 - Virtex II 3000"}
         0x83  {set infos "VHS-ADC 8 - Virtex II 4000"}
         0x84  {set infos "VHS-ADC 8 - Virtex II 6000"}
         0x85  {set infos "VHS-ADC 8 - Virtex II 8000"}
         0x8a  {set infos "VHS-ADC 8 - XC4LX40"}
         0x8b  {set infos "VHS-ADC 8 - XC4LX60"}
         0x8c  {set infos "VHS-ADC 8 - XC4LX80"}
         0x8d  {set infos "VHS-ADC 8 - XC4LX100"}
         0x8e  {set infos "VHS-ADC 8 - XC4LX160"}
         0x8f  {set infos "VHS-ADC 8 - XC4SX55"}
         default  {set infos "Unknown"}
    }

    InsertLog "Slot\[$boardID\]: Main Board:\t\t\t $infos"

    set uifpga_daughter_present [expr ($rc2 & 0x00000200) >> 9]
    set uidaughter_id [expr ($rc2 & 0x00000004) >> 2]
    set uidaughter_present [expr ($rc2 & 0x00000002) >> 1]

    if {$uifpga_daughter_present == 0} {
        if {$uidaughter_present == 1} {
            if {$uidaughter_id == 0} {    ;# daughter is a DAC
                set infos "VHS-DAC 8"
            } else {
                set infos "VHS-ADC 8"
            }
        } else {
            set infos "No daughter board present"
        }
    } else {
        set infos "FPGA hardware module"
    }

    InsertLog "Slot\[$boardID\]: Hardware module:\t\t $infos"
    InsertLog "Slot\[$boardID\]: FPGA Core Revision:\t\t $rc1"

#    print ADC max speed

    switch [expr $adc_speed_status & 3] {
         0  {set infos "65 MHz"}
         1  {set infos "80 MHz"}
         2  {set infos "105 MHz"}
         default  {set infos "Unknown"}
    }

    InsertLog "Slot\[$boardID\]: ADC Maximum Speed:\t\t $infos"

#    print ADC analog bandwidth

    switch [expr ($cpld_status & 0x18) >> 3] {
         0  {set infos "A - BW = 30MHz,DR = 26dB"}
         1  {set infos "B - BW = 100MHz,DR = 17.5dB"}
         2  {set infos "C - BW = 200MHz,DR = 14dB"}
         default  {set infos "Unknown"}
    }

    InsertLog "Slot\[$boardID\]: Programmable Gain Option:\t $infos"

#    print CPLD version

    InsertLog "Slot\[$boardID\]: CPLD Revision:\t\t $cpld_revision"

#    print PCB revision

    InsertLog "Slot\[$boardID\]: PCB Hardware Revision:\t $pcb_revision"
    
    }
        set boardID $board_SAVE

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}
                   HELP     {Help $vl}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   CRATE     {SelectVHSADCCrate $vl}
                   ALLCRATES {set ::LyrTech::allcrates [expr ($::LyrTech::allcrates + 1) & 1]}
                   BOARD     {SelectVHSADCBoard $vl}
                   ALLBOARDS {set ::LyrTech::allboards [expr ($::LyrTech::allboards + 1) & 1]}

                   ULABEL    {}

                   REPORT    {do_Report}
                   BOARDREGS {do_BoardRegs}

                   EXPERT   {
                     switch $vl {
                       Help {Help $vl}
                       default {$vl [third [lindex $cgidata 1]]}
                     }
                   }

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

     SelectVHSADCCrate $crateID

}   ;# end of if {$started == 0}




