
#    Note:  This is loaded into the namespace  LyrTech_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable Project
    set Project $::DataAcquisition::PROJECT

    variable DBNameList {"xxx"}

   variable index 0
   variable selected -1
   variable brdselected 0xff

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        variable brdselected
        global MIDAS_DataAcquisitionControlServer_Exists
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        variable Project

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=[format 0x%x $selected]; brdselected=[format 0x%x $brdselected]"
        InsertLog "DBPath = [set ::LyrTech::DBRootName]/[set ::LyrTech::DBNodeBase]/[set ::LyrTech::DBNodeName]"

        foreach LyrTech [set ::LyrTech::crateList] {InsertLog "$LyrTech"}

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
         InsertLog "MIDAS_DataAcquisitionControlServer_Exists = $MIDAS_DataAcquisitionControlServer_Exists"
       }

       if {[info exists DataAcquisitionControlServerHost]} then {
         InsertLog "DataAcquisitionControlServerHost = $DataAcquisitionControlServerHost"
       }

        InsertLog "ACQSERVER: $::DataAcquisition::ACQSERVER"
        InsertLog "AcqOption: $AcqSetOption"

        InsertLog "State = [do_getstate]"

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"

   }

      proc Selection {} {
          variable selected

          set selected 0

           set i 1
           foreach item $::LyrTech::crateList {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }
      
      proc do_SelectBRD {i} {
         variable brdselected
         
         if {$i < 0} {set brdselected 0xff; return}

         set brdselected [expr $brdselected | (1 << [expr 7-$i])]
      }

      proc do_UnSelectBrd {i} {
         variable brdselected
         
         if {$i < 0} {set brdselected 0; return}

         set brdselected [expr $brdselected & ~(1 << [expr 7-$i])]
      }


    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO OPTION returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc do_getstate {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetState} m]
      }

        if {$rc != 0} {
#            InsertLog "DO GETSTATE returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO GETSTATE returned $m"
            set rc [second $m]
        }

       return $rc

     }

      proc do_Save {} {
        variable selected
        variable brdselected

         if {$selected == 0} {Selection}
      
        InsertLog "[date +%Y%h%d-%H.%M.%S] Saving LyrTech settings to $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"

           set i 0
           foreach LyrTech $::LyrTech::crateList {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

             set ::DataAcquisition::ACQSERVER $LyrTech
             do_setopt "ParameterSave=$::LyrTech::DBNodeBase $brdselected"

             InsertLog "LyrTech settings saved for $::DataAcquisition::ACQSERVER"
          }

        InsertLog "[date +%Y%h%d-%H.%M.%S] LyrTech settings saved to $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"

#        Elog INFORMATION "LyrTech settings saved to $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"

        do_DBUpdate
    }

      proc do_Restore {} {
        variable selected
        variable brdselected

         if {$selected == 0} {Selection}
      
        InsertLog "Restoring LyrTech settings from $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"
        
          set i 0
          foreach LyrTech $::LyrTech::crateList {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

             set ::DataAcquisition::ACQSERVER $LyrTech
             do_setopt "ParameterRestore=$::LyrTech::DBNodeBase $brdselected"
 
             InsertLog "LyrTech settings restored for $::DataAcquisition::ACQSERVER"
          }

        InsertLog "LyrTech settings restored from $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"

#       ::LyrTech::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "LyrTech settings restored from $::LyrTech::DBRootName/$::LyrTech::DBNodeBase"

       do_DBUpdate
    }

      proc do_DBName {vl} {
         global Options

          set ::LyrTech::DBNodeBase $vl
          DBCreateNode $::LyrTech::DBRootName/$::LyrTech::DBNodeBase
          set Options(VHSADC.settings) $vl
          SaveOptions

          InsertLog "Data Base node $::LyrTech::DBRootName/$::LyrTech::DBNodeBase contains [DBGetNodes $::LyrTech::DBRootName/$::LyrTech::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes [set ::LyrTech::DBRootName] *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE  {do_Restore}
                SAVE     {do_Save}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}
                SELECTBRD    {do_SelectBRD [lindex $w 1]}
                UNSELECTBRD  {do_UnSelectBRD [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

     Selection

     do_DBUpdate
     LoadOptions

     set html ""


}  ;# end of if {$started == 0}

