

set Apply 0

proc make_GUI {} {
    global numchans chan ChanMenu TLenMenu allchans allmodules

#    GUI interface for MWD firmware

  set TrigMenu [list "External only" "CFD only" "Hit Pattern only" "CFD + Hit Pattern"]
 
  :frame "[self frame-name].user" :label "Firmware Parameter Control (User Level)" :resize F 

   :panel MODULE  :layout T :padx 10 :pady 10
     :layout H; :row-gap 10; :col-gap 10

    :number CRT-NUM   :label "Crate Number:" :w 2
    :number MOD-NUM :label "Board Number:" :min -1 :max -1 :w 2 :value -1
    :menubutton MOD-SEL :label "" :menu "none"

     :number CHAN-NUM     :label "Channel Number:" :min 1 :max $numchans :w 3 :value $chan
     :menubutton CHAN-SEL :label "select:" :strings $ChanMenu
     :hskip 150
     :checkbox ALL-MODULES :label "Act on ALL Boards?"  :value $allmodules
    :next-row T
     :text CHLABEL :label "Channel User Label" :deaf T :w 25
     :hskip 100
     :message VERSION :label "Firmware Version *.* dated ******" :bold T
     :hskip 100
     :checkbox ALL-CHANS   :label "Act on ALL Channels?" :value $allchans
    :next-row T
      set menu {All}
      for {set i 1} {$i <= $numchans} {incr i} {lappend menu $i}
     :choice APPLY :label "Apply settings to channels(s)" :strings $menu :w 3 :exclusive F
     :button EXECUTE :label "Execute"

   :container C0 :layout T 

   :panel P0L :layout L :padx 10 :pady 0
     :layout V; :row-gap 10; :col-gap 10

      :choice CR000   :label "Channel"           :valuex 18c :strings [list enable disable] :exclusive T :value 0
      :choice CR004   :label "Trigger Polarity"  :valuex 18c :strings [list positive negative] :exclusive T :value 0
      :choice-stack TRIGMODE   :label "Trigger Mode"  :valuex 18c :strings $TrigMenu :exclusive T :value 0
      :choice CR008   :label "AI Digitial Gain"  :valuex 18c :strings [list Off *2 *4 *8] :exclusive T :value 0
      :choice-stack CR005 :label "Analogue Inspection" :valuex 18c \
         :strings [list "Decimation In" "Decimation Out" "First Average Out" "ADC (unsigned)" \
                        "TFA (top)" "TFA (mid)" "MWD Output" Trapezoid] \
         :exclusive T :value 2
      :choice CR001   :label "Baseline Subtraction"  :valuex 18c :strings [list On Off] :exclusive T :value 0
      :choice CR002   :label "Energy Digitial Gain"  :valuex 18c :strings [list Off *2 *4 *8] :exclusive T :value 0

   :panel P0M :layout L :padx 0 :pady 0
     :layout V; :row-gap 10; :col-gap 10

      :text CFD20                :label "CFD Threshold"  :w 8 :valuex 24c
      :slider TFA_SHAPING_TIME   :label "TFA Shaping Time (ns)" :min 10 :max 2560  :resolution 10 :command click_mwd_parameter
#      :text TFA_DECAY_TIME       :label "TFA Decay Time (ns)"  :w 8 :valuex 24c :command click_mwd_parameter :deaf T
      :text SHAPING_TIME         :label "Shaping Time (us)" :w 8 :valuex 24c :command click_mwd_parameter
      :text TRAPEZOID_WIDTH      :label "Rise Time"  :w 8 :valuex 24c :command click_mwd_parameter
      :text PEAK_SAMPLE_TIME     :label "Peak Sample"  :w 8 :valuex 24c :command click_mwd_parameter
      :text PEAK_SEPARATION      :label "Peak Separation"  :w 8 :valuex 24c :command click_mwd_parameter
      :text DECAY_TIME_CONSTANT  :label "Decay Time Constant (us)"  :w 8 :valuex 24c :command click_mwd_parameter

   :panel P0R :layout R :padx 0 :pady 0
     :layout V; :row-gap 10; :col-gap 10

      :text BASELINE_AVERAGE     :label "Baseline Average"  :w 8 :valuex 24c :command click_mwd_parameter
      :text BASELINE_UPDATE_TIME :label "Baseline Update Time"  :w 8 :valuex 24c :command click_mwd_parameter
      :text BASELINE_THRESHOLD   :label "Baseline Threshold"  :w 8 :valuex 24c :command click_mwd_parameter
#      :text DECAY_TIME_CONSTANT  :label "Decay Time Constant (us)"  :w 8 :valuex 24c :command click_mwd_parameter
#      :text DECIMATION_FACTOR    :label "Decimation"  :w 8 :valuex 24c :command click_mwd_parameter
#      :text MODE                 :label "Mode"  :w 8 :valuex 24c :command click_mwd_parameter

      :vskip 70
      :choice VETO21  :label "Apply Veto n" :strings [list 1 2 3 4 5 6 7 8] :exclusive F

   :container end

  :container C1 :layout T :relief R

   :panel P1L1 :layout T :padx 5 :pady 5
     :layout H; :row-gap 10; :col-gap 40

      :col-gap 0
      set menu {}
      for {set i 1} {$i <= $numchans} {incr i} {lappend menu $i}
      :choice TRIGMASKBITS :label "Hit Pattern Trigger Mask" :strings $menu :w 3 :exclusive F
      set menu {All None}
      :choice TRIGMASKOPTS :label "" :strings $menu :w 4 :exclusive T :value -1
      :col-gap 10
      :next-row T
      :choice-stack DAC70        :label "TDRI DAC Channel select"    :strings $ChanMenu :valuex 22c :value 0
      :choice-stack GPIO72       :label "GPIO Signal Channel select" :strings $ChanMenu :valuex 22c :value 0
      :choice-stack TLEN30       :label "Trace Length" :strings $TLenMenu :valuex 12c \
           :value [expr [llength $TLenMenu] - 1]
      :slider PTRG31             :label "PreTrigger Position" :valuex 16c :min 0 :max 2047
      :col-gap 10
      :next-row T
      :choice VETO71D15          :label "Veto Window"         :strings [list enable disable] :valuex 24c
      :choice VETO71D14          :label "Early Veto Window"   :strings [list enable disable] :valuex 18c
      :slider VETO71             :label "Veto Coinc Window (10ns)" :valuex 24c :min 1 :max 16384
      :col-gap 10
      :next-row T
      :message MM1 :label "Veto delays (ns)"
      :hskip 100
      :choice VENABLE :label "Veto Enable" :strings [list 1 2 3 4 5 6 7 8] :exclusive F
      :next-row T
      for {set i 1} {$i <= 4} {incr i} {
         :slider VDELAY[expr 72+$i] :label $i :min 0 :max 1270 :resolution 10
      }
      :next-row T
      for {set i 5} {$i <= 7} {incr i} {
         :slider VDELAY[expr 72+$i] :label $i :min 0 :max 1270 :resolution 10
      }
         :slider VDELAY7A :label $i :min 0 :max 1270

   :container end

   :panel BUTTONS :layout B :padx 5 :pady 5  :after FOOTER
     :layout H; :row-gap 10; :col-gap 10

      :button USERDONE  :label "Done" :command "frame-quit [self frame-name].user"
      :button USERUPDTE :label "Update" :command update_UserGUI

  :show T

   update_UserGUI
}

proc update_UserGUI {} {
    global boardID BoardNum CrateNum ChanNum CustomLayout TLenMenu
    global boardlist maxboards
    global chan

    global UserReg RegList
    foreach reg $UserReg {global MWDr$reg}
    foreach reg $RegList {global Reg$reg}
    global Reg0x80 Reg0x81 Reg0x83

    :modify [self frame-name].user :busy T

    :modify CRT-NUM :min [:query CRATE-NUM :min] :max [:query CRATE-NUM :max]
    :modify CRT-NUM :value $CrateNum
    set boardmenu {}
    for {set i 1} {$i <= $maxboards} {incr i} {lappend boardmenu $i}
    :modify MOD-SEL :menu $boardmenu
    :modify MOD-NUM :min 1 :max $maxboards
    :modify MOD-NUM :value [expr 1 + $boardID]

    :modify CHAN-NUM :value $ChanNum

    if {[info exists CustomLayout($CrateNum,$BoardNum,$ChanNum)]} \
        {set text $CustomLayout($CrateNum,$BoardNum,$ChanNum)} \
        else {set text ""}
    catch {:modify CHLABEL :value $text}

#    set-footer [self frame-name].user "Reading board registers"
        Read_MWD_Registers
#    clear-footer [self frame-name].user

       :modify CR000  :value [expr ($Reg0x00 >> 0) & 1]
       :modify CR004  :value [expr ($Reg0x00 >> 4) & 1]

       :modify CR008  :value [expr ($Reg0x00 >> 8) & 3]
       :modify CR005  :value [expr ($Reg0x00 >> 5) & 7]
       :modify CR001  :value [expr ($Reg0x00 >> 1) & 1]
       :modify CR002  :value [expr ($Reg0x00 >> 2) & 3]

        set b10 [expr ($Reg0x00 >> 10) & 1]
        set b11 [expr ($Reg0x00 >> 11) & 1]
        set b12 [expr ($Reg0x00 >> 12) & 1]

        set vl -1
        if {$b10 == 0} {
          if {$b12 == 0} {set vl 0} else {set vl 1} 
        } else {
          if {$b11 == 0} {set vl 2} else {set vl 3}
        }

        :modify TRIGMODE :value $vl

        set day   [expr ((($Reg0x83 >> 12)&15)*16)+(($Reg0x83 >> 8)&15)]
        set month [expr ($Reg0x83 >> 4) & 15]
        set year  [expr ($Reg0x83 & 15) + 2000]
        :modify VERSION :label "Firmware Version $Reg0x80.$Reg0x81 dated $day/$month/$year"

        :modify CFD20    :value $Reg0x20
        :modify TRIGMASKBITS :value $Reg0x26
        :modify TLEN30   :value [lsearch $TLenMenu [expr ($Reg0x30 * 2) - 8]]
        :modify PTRG31   :value $Reg0x31

        :modify VETO21  :value $Reg0x21
        :modify DAC70   :value [expr ($Reg0x70 >> 1) & 15]
        :modify VETO71  :value [expr $Reg0x71 & 0x3fff]
        :modify VETO71D15  :value [expr ($Reg0x71 >> 15) & 1]
        :modify VETO71D14  :value [expr ($Reg0x71 >> 14) & 1]
        :modify GPIO72  :value [expr ($Reg0x72 >> 1) & 15]
      for {set i 1} {$i <= 7} {incr i} {
        :modify VDELAY[expr 72+$i] :value [expr ([set Reg0x[expr 72+$i]] & 0x7f)*10]
      }
        :modify VDELAY7A :value [expr ([set Reg0x7A] & 0x7f)*10]
      set enable 0
      for {set i 1} {$i <= 7} {incr i} {
           set enable [expr $enable + ((([set Reg0x[expr 72+$i]] >> 7) & 1) << ($i-1))]
      }
         set enable [expr $enable + ((([set Reg0x7A] >> 7) & 1) << ($i-1))]
        :modify VENABLE :value $enable

        update_mwd_parameters

    :modify [self frame-name].user :busy F
}

proc redisplay_mwd_parameters {} {
    global clock_frequency decimation_factor shaping_time  trapezoid_width
    global peak_separation decay_time_constant peak_sample_time 
    global baseline_average baseline_update_time baseline_threshold mode
    global tfa_shaping_time 
#   global tfa_decay_time

#    :modify CLOCK_FREQUENCY      :value [string range $clock_frequency 0 2]
#    :modify DECIMATION_FACTOR    :value [string range $decimation_factor 0 5]
    :modify SHAPING_TIME         :value [string range $shaping_time 0 5]
    :modify TRAPEZOID_WIDTH      :value [string range $trapezoid_width 0 5]
    :modify PEAK_SEPARATION      :value [string range $peak_separation 0 5]
    :modify DECAY_TIME_CONSTANT  :value [string range $decay_time_constant 0 5]
    :modify PEAK_SAMPLE_TIME     :value [string range $peak_sample_time 0 5]
    :modify BASELINE_UPDATE_TIME :value [string range $baseline_update_time 0 5]
    :modify BASELINE_AVERAGE     :value [string range $baseline_average 0 5]
    :modify BASELINE_THRESHOLD   :value [string range $baseline_threshold 0 5]
#    :modify MODE                 :value [string range $mode 0 5]
    :modify TFA_SHAPING_TIME     :value [string range $tfa_shaping_time 0 5]
#    :modify TFA_DECAY_TIME       :value [string range $tfa_decay_time 0 6]
}





