
 
 if {![namespace exists ::LyrTech]} {namespace eval ::LyrTech {;#puts "created namespace ::LyrTech"}}
 
   if {![info exists ::LyrTech::ModuleMenu]} {set ::LyrTech::ModuleMenu [list lyrtech01 lyrtech02]}
   if {![info exists ::LyrTech::CrateID]} {set ::LyrTech::Crate [first $::LyrTech::ModuleMenu]}

   if {![info exists ::LyrTech::TestMode]} {set rc [catch {set ::LyrTech::TestMode 0} m]}

   set rc [catch {
      if {$::LyrTech::TestMode != 0} {
         global R3BData
         set R3BData(0,0,0)  0
      }
   } m]
   
    global VHSADCAccessServerHost
    if {![info exists VHSADCAccessServerHost]} {set VHSADCAccessServerHost $::LyrTech::CrateID}
    global VHSADCAccessServerPort
    if {![info exists VHSADCAccessServerPort]} {set VHSADCAccessServerPort 8015}


    variable Verbose 1
      
    variable Rmsg ""
    variable Wmsg ""

   proc SelectVHSADCCrate {vl} {

   set z [catch {
       set ::LyrTech::crateID $vl
       SetVHSADCCrate $vl
       set ::LyrTech::boardList [second [lindex $::LyrTech::VHSADCLayOut [lsearch $::LyrTech::crateList $::LyrTech::crateID]]]
       set ::LyrTech::boardID [first $::LyrTech::boardList]
          } m]
          
      if {$z != 0} {InsertLog "Select::LyrTech::crateID $m"}
   }

    proc SelectVHSADCBoard {vl} {set ::LyrTech::boardID $vl}

    proc SetVHSADCCrate {crate} {set ::LyrTech::CrateID $crate}
    proc GetVHSADCCrate {} {return $::LyrTech::CrateID}

    proc ReadVHSADCFpgaRegister  {board offset}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Verbose
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$board,$offset)]} {set VHSADCData($::LyrTech::crateID,$board,$offset) 0xaaaa}
  InsertLog "ReadVHSADCFpgaRegister $::LyrTech::crateID,$board,$offset  reads  [set VHSADCData($::LyrTech::crateID,$board,$offset)]"
     return [set VHSADCData($::LyrTech::crateID,$board,$offset)]
  }
  
     puts "ReadVHSADCFpgaRegister $board $offset"

       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16ReadFpgaReg $board $offset} Rmsg]
			puts "#1$rc $Rmsg"
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
                if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "ReadVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16ReadFpgaReg  $board $offset"}
            set rc [catch {VHSADCAccessClient__Vhsadac16ReadFpgaReg $board $offset} Rmsg]
        }
        if {$rc != 0} {
           InsertLog "Vhsadac16ReadFpgaReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#           InsertLog "ReadVHSADCFpgaRegister Board = $board; Offset=[format \"0x%x\" $offset] => $Rmsg [format \"0x%x\" $Rmsg]"
        }
        return $Rmsg
    }

    proc WriteVHSADCFpgaRegister  {board offset vl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Verbose
        variable rc 0
        variable Wmsg

  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
  InsertLog "WriteVHSADCFpgaRegister $::LyrTech::crateID,$board,$offset  writes  $vl"
     set VHSADCData($::LyrTech::crateID,$board,$offset) $vl
     return
  }
  
       puts "WriteVHSADCFpgaRegister $board $offset $vl"


       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister VhsadacWriteFpgaReg $board $offset $vl"}
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
                if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister configure $VHSADCAccessServerHost"}
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "WriteVHSADCFpgaRegister  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16WriteFpgaReg"}
            set rc [catch {VHSADCAccessClient__Vhsadac16WriteFpgaReg $board $offset $vl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg returned with an error\n$Wmsg\n$errorCode\n$errorInfo"}
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "Vhsadac16WriteFpgaReg Board = $board; Offset=[format \"0x%x\" $offset] $vl => $Wmsg [format \"0x%x\" $Wmsg]"}
        }
        return $Wmsg
    }

    proc ReadVHSADCUserRegister {chan reg} {
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16)]        ;#    build data for register
        set value [ReadVHSADCUserRegisters $boardID $regvl] 
        return $value
    }

    proc WriteVHSADCUserRegister {chan reg vl} {
       set boardID [set ::LyrTech::boardID]

        set regvl [expr ($chan << 28) + ($reg << 16) + $vl]        ;#    build data for register
        WriteVHSADCUserRegisters $boardID $regvl   
    }

    proc ReadVHSADCUserRegisters {board regvls} {

      set rc {}
      foreach regvl $regvls {

         if {$::LyrTech::TestMode != 0} {
             global VHSADCData
             if {![info exists VHSADCData($::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff])]} {set VHSADCData($::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff]) 0xaaaa}
 InsertLog "ReadVHSADCUserRegister $::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff]  reads  [set VHSADCData($::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff])]" 
             lappend rc [set VHSADCData($::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff])]
          } else {
             lappend rc [__ReadVHSADCUserRegisters $board $regvl]
          }

      }

      return $rc
    }
    
    proc  __ReadVHSADCUserRegisters  {board regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Verbose
        variable Rmsg
        variable rc 0

       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
# puts "ReadVHSADCUserRegister $board $regvl"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCReadUserRegs $board $regvl} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
# puts "ReadVHSADCUserRegisters configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "ReadVHSADCUserRegister  $VHSADCAccessServerHost  VHSADCAccessClient__ReadUserReg"
            set rc [catch {VHSADCAccessClient__ReadUserRegs $board $regvl} Rmsg]
        }
        if {$rc != 0} {
            InsertLog "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
# puts "ReadUserReg returned with an error\n$Rmsg\n$errorCode\n$errorInfo"
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "ReadUserReg $board $regvl  => $Rmsg [format \"0x%x\" $Rmsg]"}
# puts "ReadUserReg $board $regvl => $Rmsg [format \"0x%x\" $Rmsg]"
        }
        return $Rmsg
    }


    proc WriteVHSADCUserRegisters {board regvls} {

       set rc {}
       foreach regvl $regvls {

          if {$::LyrTech::TestMode != 0} {
             global VHSADCData
  InsertLog "WriteVHSADCUserRegister $::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff]  writes  [expr $regvl & 0x0000ffff]"
             set VHSADCData($::LyrTech::crateID,$board,[expr ($regvl >> 16) & 0x0000ffff]) [expr $regvl & 0x0000ffff]
          } else {
             __WriteVHSADCUserRegisters $board $regvl
          }
       }

       return
    }

    proc __WriteVHSADCUserRegisters  {board regvl}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Verbose
        variable rc 0
        variable Wmsg

       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
# puts "WriteVHSADCUserRegisters do_VHSADCWriteUserRegs"
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCWriteUserRegs $board {$regvl}} Wmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
# puts "WriteVHSADCUserRegisters configure $VHSADCAccessServerHost"
                VHSADCAccessClient_Configure
            }
# puts "WriteVHSADCUserRegisters  $VHSADCAccessServerHost  VHSADCAccessClient__WriteUserRegs"
            set rc [catch {VHSADCAccessClient__WriteUserRegs $board $regvl} Wmsg]
        }
        if {$rc != 0} {
            InsertLog "WriteUserRegs returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
# puts "WriteVHSADCUserRegisters returned with an error\n$Wmsg\n$errorCode\n$errorInfo"
            return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            if {$Verbose != 0} {InsertLog "WriteUserRegs $board $regvl => $Wmsg [format \"0x%x\" $Wmsg]"}
# puts "WriteVHSADCUserRegisters $board $regvl => $Wmsg [format \"0x%x\" $Wmsg]"
        }
        return $Wmsg
    }


    proc ReadVHSADCCpldRegs {board}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Verbose
        variable Rmsg
        variable rc 0
        
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$board,"cpld")]} {set VHSADCData($::LyrTech::crateID,$board,cpld) 0xaaaa}
  InsertLog "ReadVHSADCCpldRegs $::LyrTech::crateID,$board,"cpld"  reads  [set VHSADCData($::LyrTech::crateID,$board,"cpld")]"
     return [set VHSADCData($::LyrTech::crateID,$board,"cpld")]
  }

       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_Vhsadac16GetCpldRegs $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
                VHSADCAccessClient_Configure
            }
            if {$Verbose != 0} {InsertLog "ReadVHSADCCpldRegs  $VHSADCAccessServerHost  VHSADCAccessClient__Vhsadac16GetCpldRegs  $board"}
            set rc [catch {VHSADCAccessClient__Vhsadac16GetCpldRegs $board} Rmsg]
            if {$Verbose != 0} {InsertLog "ReadVHSADCCpldRegs => rc=$rc $Rmsg"}
        }
        if {$rc != 0} {
           InsertLog {"Vhsadac16GetCpldRegs returned with an error  rc=$rc\n$Rmsg\n$errorCode\n$errorInfo"}
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
           if {$Verbose != 0} {InsertLog "Vhsadac16GetCpldRegs Board = $board => $Rmsg"}
        }
        return $Rmsg
    }

    proc VHSADCInit  {}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {return [llength $::LyrTech::crateList]}
  
  puts "VHSADCInit [info exists MIDAS_VHSADCAccessServer_Exists]  $VHSADCAccessServerHost  $::LyrTech::crateID"

        if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCInit} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
                VHSADCAccessClient_Configure
            }
            set rc [catch {VHSADCAccessClient__VHSADCInit} Rmsg]

        }
        if {$rc != 0} {
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
#            InsertLog "VHSADCInit => $Rmsg [format \"0x%x\" $Rmsg]"
        }

        return $Rmsg
    }

    proc VHSADCExit  {}  {
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Exists
        global VHSADCAccessServerHost
        variable Rmsg
        variable rc 0

  if {$::LyrTech::TestMode != 0} {return 0}

       if {[info exists MIDAS_VHSADCAccessServer_Exists] && $MIDAS_VHSADCAccessServer_Exists == 1} {
            set rc [catch {interp eval "" ::namespace inscope ::urn:VHSADCAccessServer do_VHSADCExit $board} Rmsg]
        } else {
            if {$VHSADCAccessServerHost != $::LyrTech::crateID} {
                set VHSADCAccessServerHost  $::LyrTech::crateID
                VHSADCAccessClient_Configure
            }
            set rc [catch {VHSADCAccessClient__VHSADCExit} Rmsg]
        }
        if {$rc != 0} {
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        } else {
            InsertLog "VHSADCExit => $Rmsg [format \"0x%x\" $Rmsg]"
        }
        return $Rmsg
    }





